<?php
//--------------------------------------------------------------------
// *** Anti-Spam Module for Comment (asm4cmt) ***
// LAST UPDATE: 2005/08/05
// Version    : 1.10
// Copyright  : nJOY
// http://njoy.pekori.to/
//--------------------------------------------------------------------
//
// asm4cmt.php
//
//--------------------------------------------------------------------

require "./".BLOGN_MODDIR."asm4cmt/function.php";

function antispam_input_comment($user, $entry_id, $name, $email = "", $url = "", $mes, $set_cookie, $ip, $agent) {
	$errflg = false;
	$utf_name = blogn_mbConv($name, 0, 4);
	$utf_email = blogn_mbConv($email, 0, 4);
	$utf_url = blogn_mbConv($url, 0, 4);
	$utf_mes = blogn_mbConv($mes, 0, 4);

	if (!$entry_id || !$utf_name || !$utf_mes) {
		// エラー処理
		//HTTPヘッダ送信
		$link_url = BLOGN_HOMELINK."index.php?e=".$entry_id."#comments";
		$info = 'コメント投稿エラー<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
		$errflg = true;
	}else{
		$logdata = blogn_mod_db_log_load_for_editor($entry_id);
		if (strlen($utf_mes) > BLOGN_COMMENT_SIZE && BLOGN_COMMENT_SIZE != 0) $utf_mes = blogn_mbtrim($utf_mes,BLOGN_COMMENT_SIZE);
		if ($user) {
			$comment = blogn_mod_db_comment_load_for_new(1, 0, 10);
		}else{
			$comment = blogn_mod_db_comment_load_for_new(0, 0, 10);
		}
		// 重複投稿チェック
		if ($comment[0]) {
			while (list($key, $val) = each($comment[1])) {
				if ($val["name"] == $utf_name && $val["comment"] == blogn_mod_db_rn2br($utf_mes)) {
					$link_url = BLOGN_HOMELINK."index.php?e=".$entry_id."#comments";
					$info = 'コメント重複投稿エラー<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
					$errflg = true;
					$asm4cmt_err = "重複";
					break;
				}
			}
		}
	}

	$inifile = BLOGN_MODDIR."asm4cmt/config.ini";
	$ini = parse_ini_file($inifile);
	
	// 投稿者名文字数制限
	$name_limit = $ini["namecount"];
	if (mb_strlen($utf_name) > $name_limit) $utf_name = blogn_mbtrim($utf_name, $name_limit);
	
	// 日本語チェック
	if ($ini["english"] == "1") {
		if (!preg_match("/[ぁ-んァ-ヶ亜-瑤]{15}/", $utf_mes)) {
			$link_url = BLOGN_HOMELINK."index.php?e=".$entry_id."#comments";
			$info = 'コメント投稿エラー<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
			$errflg = true;
			$asm4cmt_err = "英語コメント";
		}
	}

	// 使用禁止ワードチェック
	$data = fopen(BLOGN_MODDIR."asm4cmt/ngwd.dat", "r");
	$ng_wd = fgets($data, 2048);
	if (strlen($ng_wd)) {
		$ng_wd = preg_replace("/[,]+$/", "", $ng_wd);
		$ng_wd = explode(",", $ng_wd);
		if (is_array($ng_wd)) {
			foreach ($ng_wd as $deny_wd) {
				if (preg_match("/$deny_wd/i", $utf_mes) || preg_match("/$deny_wd/i", $utf_url)) {
					$link_url = BLOGN_HOMELINK."index.php?e=".$entry_id."#comments";
					$info = 'コメント投稿エラー<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
					$errflg = true;
					$asm4cmt_err = "禁止ワード";
				}
			}
		}
	}
	fclose($data);

	if (!$errflg){
		$date = gmdate("YmdHis",time() + BLOGN_TIMEZONE);
		$error = blogn_mod_db_comment_add($entry_id, $logdata[1]["secret"], $date, blogn_html_tag_convert($utf_name), blogn_html_tag_convert($utf_email), blogn_html_tag_convert($utf_url), blogn_html_tag_convert($utf_mes), $ip, $agent);
	}else{
		$date = gmdate("YmdHis",time() + BLOGN_TIMEZONE);
		$asm4cmt_file = BLOGN_MODDIR."asm4cmt/rejected.log";
		$fp = fopen("$asm4cmt_file", "a+");
		$time = date("Y/m/d H:i:s");
		$utf_name = asm4cmt_format_data($utf_name);
		$utf_email = asm4cmt_format_data($utf_email);
		$utf_url = asm4cmt_format_data($utf_url);
		$utf_mes = asm4cmt_format_data($utf_mes);
		$asm4cmt_data = $entry_id.','.$asm4cmt_err.','.$date.','.$utf_name.','.$utf_email.','.$utf_url.','.$utf_mes.','.$ip.','.$agent."\n";
		fwrite($fp, $asm4cmt_data);
		fclose($fp);
	}


	if ($error[0]) {
		$link_url = BLOGN_HOMELINK."index.php?e=".$entry_id."#cmt".$error[2];
		$info = 'コメントを投稿しました。<br><br>画面が自動的に切り替わらない場合は<br><a href="'.$link_url.'">こちら</a>をクリックしてください。';
		$userlist = blogn_mod_db_user_load();

		$logdata = blogn_mod_db_log_load_for_editor($entry_id);
		$sub = "コメントを受信しました";
		$sub = blogn_mbConv($sub, 4, 3);
		$sub = "=?iso-2022-jp?B?".base64_encode($sub)."?="; 
		$mes = "件名:".$logdata[1]["title"]."\n"; 
		$mes .= "投稿者名:".$utf_name."\n"; 
		$mes .= "URL:".BLOGN_HOMELINK."index.php?e=".$entry_id."#cmt".$error[2]."\n"; 
		$mes .= "※このメールアドレスには返信しないでください。"; 
		$mes = blogn_mbConv($mes, 4, 3); 
		$from = BLOGN_SITENAME; 
		$from = blogn_mbConv($from, 4, 3); 
		$from = "=?iso-2022-jp?B?".base64_encode($from)."?="; 
		$from = "From: $from <blognplus@localhost>\nContent-Type: text/plain; charset=\"iso-2022-jp\""; 

		while (list($key, $val) = each($userlist)) {
			if ($val["information_comment"]) @mail($val["information_mail_address"], $sub, $mes, $from); 
		}
	}

	$errdata = '
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
<meta http-equiv="refresh"content="2;URL='.$link_url.'">
<meta http-equiv=content-type content="text/html; charset='.$charset.'">
</head>
<body>
<div align="center">
<div style="text-align:center;border:1px solid;width:400px;">'.$info.'</div>
</div>
</body>
</html>';


	if (BLOGN_CHARSET == 0 || BLOGN_MOBILE_KEY == 1) {
		$charset = "Shift_JIS";
		$outkey = 2;
	}elseif (BLOGN_CHARSET == 1) {
		$charset = "EUC-JP";
		$outkey = 1;
	}elseif (BLOGN_CHARSET == 2) {
		$charset = "UTF-8";
		$outkey = 4;
	}

	if ($set_cookie == "on") {
		setcookie("name", blogn_mbConv($name, 0, 4), time() + BLOGN_TIMEZONE + 604800);
		setcookie("email", blogn_mbConv($email, 0, 4), time() + BLOGN_TIMEZONE + 604800);
		setcookie("url", blogn_mbConv($url, 0, 4), time() + BLOGN_TIMEZONE + 604800);
	}

	header("Content-Type: text/html; charset=$charset");
	if ($outkey != 4) $errdata = blogn_mbConv($errdata, 4, $outkey);
	if ($outkey == 2) $errdata = blogn_magic_quotes($errdata);
	echo $errdata;
	exit;
}

?>
